<template>
  <v-app class="receiptReport">
    <div class="receiptReport__title">
      <h1>Выписка рецепта</h1>
    </div>

    <div class="receiptReport__subtitle">
      <h2>Нажмите для создания отчёта</h2>
    </div>

    <v-dialog v-model="dialog" max-width="500px">
      <template v-slot:activator="{ on, attrs }">
        <v-btn class="receiptReport__btn" v-bind="attrs" v-on="on" style="margin-right: auto" @click="loadPage">
          Создать
        </v-btn>
      </template>
      <v-card>
        <v-card-title>
          <span class="text-h5">{{ "Получить отчёт" }}</span>
        </v-card-title>

        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12" sm="6" md="12">
                <v-overflow-btn v-model="dialogItem" :items="patients" item-value="id" label="Пациент"
                                :item-text="item => item.surname +' ' + item.name + ' ' + item.fatherName"/>
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>

        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="#AFFFCF" @click="close">Закрыть</v-btn>
          <v-btn color="#AFFFCF" @click="requestReport">Получить отчет</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-app>
</template>

<script>
import axios from "axios";

export default {
  name: "ReceiptReport",
  data() {
    return {
      dialog: false,
      patients: [],
      medicalCards: [],
      dialogItem: {
        id: ''
      },
      pdfsrc: '',
    }
  },

  mounted() {
    this.fetchReceipt()
  },

  methods: {
    async fetchReceipt() {
      axios
          .get(this.$root.globalVar + '/medical_card')
          .then(response => {
            this.medicalCards = response.data
            console.log(response.data)
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
    },

    async fetchReport(id) {
      axios
          .post(this.$root.globalVar + '/reports/receipt_report/medical_card/' + id, {}, {
            responseType: 'blob'
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
            console.log(id)
            console.log(this.$root.globalVar + '/reports/payment_of_treatment_report/patient/' + id)
          })
          .then(response => {
            console.log("Success", response);
            const blob = new Blob([response.data], {type: 'application/pdf'});
            console.log(blob)
            const objectUrl = URL.createObjectURL(blob);
            this.pdfsrc = objectUrl;
            console.log(objectUrl);
            window.open(objectUrl)
            this.checker = true;
          })
    },

    close() {
      this.dialog = false
    },

    loadPage() {
      this.medicalCards.forEach(medicalCard => this.patients.push(medicalCard.patient))
    },

    requestReport() {
      console.log(this.dialogItem)
      this.fetchReport(this.dialogItem)
      this.dialog = false
    }
  }
}
</script>

<style lang="scss" scoped>
.receiptReport {
  &__title {
    text-align: center;
    margin: 60px 0 30px 0;
  }

  &__subtitle {
    margin: 0 0 20px 50px;
  }

  &__btn {
    margin-left:50px;
  }
}
</style>